#include <ezwin.h>
#include <cassert>
#include <cstdio>
#include "rect.h"

// Create a 10cm x 10cm window, with title "Lines"
SimpleWindow A("Axis", 30.0, 15,
                       Position(3.0, 1.0));

//Defining function 
//M:Max, m:min
void axis(float M,float m,float k){
        float p; // p is value of cordinate
        float f,z;
        float i;
        
        //X-axis
        A.RenderLine(Position(2,13), Position(30,13), Black, 0.0);

        //scaling factor: distance between two points
        f=(M-m)/10;  
        if (k==(-1)){
                for (i=1;i<10;i++){
                        z=13+i*f; // z is increment factor
                        A.RenderLine(Position(2+z,13-0.2), Position(2+z,13+0.2), Blue, 0.0);
                        p=m + i*f;
                        char*str=new char[30];
                        sprintf(str,"%g",p); // converting float value to string for printing on interface
        
 
                        Position UpperLeft = Position(2+z,14) + Position(-0.5, -0.5);
                        Position LowerRight = Position(2+z,14) + Position(0.5,  0.5);

                        // Display the values of cordinates
                        A.RenderText(UpperLeft, LowerRight, str, Red);

                }
        }
  
        //Y-axis  
        if (k!=(-1)){
                A.RenderLine(Position(2*(k+1),1), Position(2*(k+1),13), Black, 0.0);
                for(i=1;i<10;i++){
                        z=13-i*f; // z is decrement factor
                        A.RenderLine(Position(2*(k+1)-0.2,z), Position(0.2+2*(k+1),z), Blue, 0.0); 
                        p=m + i*f;
                        char*str=new char[30];
                        sprintf(str,"%g",p);
        
 
                        Position UpperLeft = Position(1+2*k,z) + Position(-0.5, -0.5);
                        Position LowerRight = Position(1+2*k,z) + Position(0.5,  0.5);

                        // Display the text
                        A.RenderText(UpperLeft, LowerRight, str, Red);        
                }
        }        

}


int ApiMain() {
         A.Open();
        assert(A.GetStatus() == WindowOpen);
        axis (10,1,(3)); //invoking the function for the given values of M, m and k
}


