//#include "stdafx.h"
#include<stdio.h>
#include<iostream>
#include<string>
#include<assert.h>
#include"ezwin.h"
#include"bitmap.h"
#include<cmath>
#include <cstring>
#include <cstdio>
#include<cassert>
#include"fparser.hh"
using namespace std;




//Macros
#define NO_OF_CONTROLS 6
#define NO_GRAPHS 4
#define NO_UTILITIES 3
#define NO_POINTS 5000
#define X_WIN_DIM 15
#define Y_WIN_DIM 15







// Structure prototype containing all parameters for graph
typedef struct{
	int Auto;
	int cb[3];
	string function;
	string scaling_factor_y;
	color colour;
	float scalingfactor;
} GraphData;





// seperate declaration for interval on x because it is common to all four graphs
string start_domain= "-5";
string end_domain= "5";
float xstart = -5 ;
float xend = 5;
//sscanf (start_domain,"%g",&xstart);      // sscanf converts the string to a float
//sscanf (end_domain,"%g",&xend);




// Definition of interface and graph windows
SimpleWindow W("Interface window",
	       10.0, 4.0, Position(5.0, 6.0));

SimpleWindow G("Graph window",
	       X_WIN_DIM, Y_WIN_DIM, Position(1, 1));







// Array of all bitmaps on the  interface screen
BitMap Graph_Cntrs [ NO_GRAPHS][NO_OF_CONTROLS ];







//initializing all parameters for all 4 graphs
 GraphData GraphConfig [NO_GRAPHS]= {
	{ 1,{0,0,0},"sin(x)","1",Red,1},
	{ 1,{0,0,0},"cos(x)","1",Blue,1},
	{ 1,{0,0,0},"tan(x)","1",Green,1},
	{ 1,{0,0,0},"exp(x)","1",Yellow,1},
	};
 




// array of offset in positions to allow for 4 copies of the same layout for the four functions
Position Offset[NO_GRAPHS] = { Position(0,0), Position(15,0), Position(0,7.5), Position(15,7.5) }; 
	




//Array to store all points to be plotted
float points[NO_GRAPHS][NO_UTILITIES][NO_POINTS];









//*******THE FUNCTIONS********
 






//Defining function 
//M:Max, m:min
void axis(int i,float scalingy){
        float X=15.5,D;
        float M ;
        float m ;
        float shift;       
        float p; // p is value of cordinate
        float f,z;
        int k,j;
        
        if (i<0){
        M = xend; m= xstart;
        }
 
        else{ 
	M = points[i][0][0];
	for (j=1 ; j < NO_POINTS;j++)
	{
		if (M <= points[i][0][j])
		{
			M = points[i][0][j];
		}
	}
	

	m = points[i][0][0] ;
	for (j=1 ; j < NO_POINTS;j++){
	    if (m > points[i][0][j]) m = points[i][0][j];
	}
        }  



        D = (M - m)*scalingy/10;       

        shift = -1*  Y_WIN_DIM/2 + 5*D - 0.5;

   
        //X-axis
        G.RenderLine(Position(2,X), Position(30,X),Black, 0.0);

        //scaling factor: distance between two points
        f=(M-m)/10;  
        if (i==(-1)){
                for (k=0;k<11;k++){
                        z=X+k*D; // z is increment factor
                        G.RenderLine(Position(z-7.5,X-0.2), Position(z-7.5,X+0.2), Black, 0.0);
                        p=m + k*f;
                        if(abs(p)<=0.01) G.RenderLine( Position(z-7.5,0), Position(z-7.5, 15.5), Black, 0.0);
                        char*str=new char[30];
                        sprintf(str,"%g",p); // converting float value to string for printing on interface
        
 
                        Position UpperLeft = Position(z-7.5,X+1) + Position(-0.5, -0.5);
                        Position LowerRight = Position(z-7.5,X+1) + Position(0.5,  0.5);

                        // Display the values of cordinates
                        G.RenderText(UpperLeft, LowerRight, str, Black);

                }
        }
  
        //Y-axis  
        if (i!=(-1)){
                G.RenderLine(Position(2*(i+1),0.2), Position(2*(i+1),X), GraphConfig[i].colour, 0.0);
                for(k=0;k<11;k++){
                        z=X-k*D + shift ; // z is decrement factor
                        G.RenderLine(Position(2*(i+1)-0.2,z), Position(0.2+2*(i+1),z), GraphConfig[i].colour, 0.0); 
                        p=m + k*f;
                        if(abs(p) <= 0.01) {
                          G.RenderLine(Position(8,z), Position(23,z), Black, 0.0);
                          G.RenderLine(Position(23,z), Position(24,z), GraphConfig[i].colour, 0.1);
			} 
                           
                        char*str=new char[30];
                        sprintf(str,"%g",p);
        
 
                        Position UpperLeft = Position(1+2*i,z) + Position(-0.5, -0.5);
                        Position LowerRight = Position(1+2*i,z) + Position(0.5,  0.5);

                        // Display the text
                        G.RenderText(UpperLeft, LowerRight, str, GraphConfig[i].colour);        
                }
        }        

}






















//These dummy func. will be replaced by the parsing func.& utilities

float f(float x,string function ){	
        FunctionParser fp;
        fp.Parse(function,"x");
        double variable[]={x};
        double result=fp.Eval(variable);       
	return result;
}

float derivative(float x,string str ){
       float h= 0.0001;	
       float y1;
       y1=(f(x+h,str)-f(x,str))/h;  			/*Using first principle,right hand derivative*/
       return y1;
		
	}

float integral(float x,string str)
{	
	float h=(xend-xstart)/NO_POINTS;
        float b,d;
        b=b+h*f(x,str);	
	return b;
	
	}
int maxmin(string str)
{
	float h=0.01;
	float i;
	double y1,y2,y3,y4,y5,y6;
	int x;
	float p;
	for(i=xstart;i<=xend;i=i+h){			//for loop to calculate derivative
		y1=(f(i+h,str)-f(i,str))/h;  		/*Using first principle, right hand derivative*/
		//plot (x,y1)
		y2=(f(i-h,str)-f(i,str))/-h;
		/*left hand derivative, useful for findin local maxima and minima*/
		y3=(f(i+2*h,str)-f(i+h,str))/h;
		if(y1<0 && y2>0){
			if(i!=0){
			x=(i+0.001*abs(i)/i)*100;
			p=x/(float)100;
			}
			cout<<"x="<<p<<" is a point of local maxima"<<endl;
			
		}
		if(y1>0 && y2<0){
			if(i!=0){
			x=(i+0.001*abs(i)/i)*100;
			p=x/(float)100;
			}
			cout<<"x="<<p<<" is a point of local minima"<<endl;
			
		}
/*		if (y3>y1 && y2>y1) {
			if(i!=0){
			x=(i+0.001*abs(i)/i)*100;
			p=x/(float)100;
			}
			cout<< "x=" << p <<" is a 2 point of inflection."<< endl;
			
		}
		if (y3<y1 && y2<y1) {
			if(i!=0){
			x=(i+0.001*abs(i)/i)*100;
			p=x/(float)100;
			}
			cout<< "x=" << p << " is a 1 point of inflection."<<endl;
			
			
		}*/
	}
}				 

void area_curve(string str)
    {  float a=0,h=0.001,i,p;
int x;


	for(i=xstart;i<=xend;i=i+h){ 				/*for loop for area under the curve*/	
		a=a+h*abs(f(i,str));			
		}
                if(a!=0){
			x=(a+0.0001*abs(a)/a)*1000;
			p=x/(float)1000;
			}
	cout<<"Area under the curve is "<<p<<endl;
}
/*void eqn_tangent(float x,string str){
	i=0;
       float y;
	y=f(x,str);;
	m=(f(x+h2,str)-f(x-h2,str))/2*h2;
	c=y-mx;		
        //using slope point form
	cout<<"Equation of tangent is y="<<m<<"*x+"<<c<<endl;
	}

void eqn_normal(float x, string str){
	float y;
	y=f(x,str);
	m=-2*h2/(f(x+h2,str)-f(x-h2,str));
	c=y-mx; 		//using slope point form
	cout<<?Equation of tangent is y=?<<m<<?*x+?<<c<<endl;
	}
*/


void root(string str){			//finds roots of the function
	float a=0,h=0.001,p,q=-5;
int x,g=0;
	for(a=xstart;a<=xend;a=a+h){
             		
             if(abs(f(a,str))<h)
	        {    if(a!=0){
                        g++; 
			x=(a+0.001*abs(a)/a)*100;
			p=x/(float)100;
                                                    
			
                     if (g%2==0)
                     cout<<p<<" is a root"<<endl;
                }
		}	
 }

}





//******Function to read values from text file*******
void read()
{
 int n,j; 
 float lower_limit,upper_limit,scaling_factor_1,scaling_factor_2,scaling_factor_3,scaling_factor_4;
 FILE *def;
 char inputline[100],function[10][100];
 string str_1,str_2,str_3,str_4;
 def=fopen("inputfile.txt","r");
 for (j=0;j<10;j++) //taking functions and domain from text file into strings and copying them into individual string
 {
  fgets(inputline,100,def);
  memcpy(function[j],inputline+34,100);
  // printf("%s",function[j]); 
 }
 //converting necessary parameters from string to floats
  sscanf(function[1],"%f",&xstart);
  sscanf(function[2],"%f",&xend);
  sscanf(function[3],"%f",&GraphConfig[0].scalingfactor);
  sscanf(function[5],"%f",&GraphConfig[1].scalingfactor);
  sscanf(function[7],"%f",&GraphConfig[2].scalingfactor);
  sscanf(function[9],"%f",&GraphConfig[3].scalingfactor);
   
  //converting char array into string object
  GraphConfig[0].function=function[0];
  GraphConfig[1].function=function[4];
  GraphConfig[2].function=function[6];
  GraphConfig[3].function=function[8];
  
  GraphConfig[0]. scaling_factor_y = function[3];
  GraphConfig[1]. scaling_factor_y = function[5];
  GraphConfig[2]. scaling_factor_y = function[7];
  GraphConfig[3]. scaling_factor_y = function[9];

  start_domain = function[1];
  end_domain = function[2];   
// cout<<"enter function\n";
 
 
// fputs(function1,def+14); 
//}
fclose(def);
}








//The scaling functions
float autoscalex (float start, float end){
	float scaling;
	scaling = X_WIN_DIM / (end - start);
	return scaling;
}


float autoscaley ( int i)
{
	float max,min,scaling;
	int j;
    
	max = points[i][0][0];
	for (j=1 ; j < NO_POINTS;j++)
	{
		if (max <= points[i][0][j])
		{
			max = points[i][0][j];
		}
	}
	

	min = points[i][0][0] ;
	for (j=1 ; j < NO_POINTS;j++){
	    if (min > points[i][0][j]) min = points[i][0][j];
	}
	

	scaling = Y_WIN_DIM / (max-min);
	return scaling;
}



//The shift of origin function

Position originshift (float xstart,float scalingx, float scalingy, int i)
{
  float max,min,mean,x,y;

	int j;
        max = points[i][0][0];
	for (j=1 ; j < NO_POINTS;j++){
		if (max < points[i][0][j]) max = points[i][0][j];
	} 

    	min = points[i][0][0] ;
	for (j=1 ; j < NO_POINTS;j++){
	    if (min > points[i][0][j]) min = points[i][0][j];
	}
        
        mean = (max + min)/2;
        

	x = -1 * xstart * scalingx;
	y =  mean * scalingy + Y_WIN_DIM/2 +1;
	Position shift = Position(x,y);
	return shift;
}




                                          
      



























// ***THE PLOTTING FUNCTION***

void plotgraph() {
    
	float x,y,p,q,scalingx,scalingy;int i,j,k;
	float p_old, q_old;
    Position shift_of_origin;


	G.Open();



	//The values to be plotted are stored first

    for (i=0;i<NO_GRAPHS;i++)
	{
		for(j=0;j<NO_UTILITIES;j++)
		{
			for(k=0;k<NO_POINTS;k++)
			{
				x = xstart + k*(xend-xstart)/NO_POINTS;

				switch (j)
				{
				case 0:
					y = f(x, GraphConfig[i].function);
					break;
				case 1:
					y = derivative(x,GraphConfig[i].function);
					break;
                                case 2:
					y = integral(x,GraphConfig[i].function);
					break;
				}
				points[i][j][k]=y;
			}
		}
	}

        
    
         
	

	//Now they are plotted

	for(i=0; i<NO_GRAPHS; i++)
	{
		for (j=0; j< NO_UTILITIES; j++)
		{
			if(GraphConfig[i].cb[0]==1 ){

                        if(j==0){
                        maxmin(GraphConfig[i].function);
                        root(GraphConfig[i].function);
                        area_curve(GraphConfig[i].function);
                        }
                        
                           
                        if (GraphConfig[i].cb[j]==1)   

			{
				if (GraphConfig[i].Auto ==1)
				{
					scalingy = autoscaley(i);
				}
				else
				{
					scalingy = GraphConfig[i].scalingfactor *  autoscalex(xstart,xend);
				}
				scalingx = autoscalex(xstart,xend);

				shift_of_origin = originshift(xstart,scalingx,scalingy,i);
				for (k=0 ; k<NO_POINTS ; k++)
				{
					x = xstart + k*(xend-xstart)/NO_POINTS;
					y = points[i][j][k];
					p = x * scalingx + 8;
					q =-1 * y * scalingy;
                                       
					if( k==0)
					{
						p_old = p;
						q_old = q;
					}
					G.RenderLine(Position(p_old,q_old) + shift_of_origin,Position(p,q) + shift_of_origin,GraphConfig[i].colour,0.0);
					p_old =p;
					q_old =q;
					//G.RenderLine(Position(p,q) + shift_of_origin,Position(p + .001, q - .001) + shift_of_origin,GraphConfig[i].colour,0.0);
				}
                                axis(i,scalingy);

			}
		}
	}



}
axis(-1,scalingx);

}
























//The mouseclick callback function
int click(const Position &MP) 
{
	int i, j, flag_clickOnControl =0;

	for (j =0; j< NO_GRAPHS ; j++)
	{
		for (i =0; i<NO_OF_CONTROLS ; i++)
		{
			if ( Graph_Cntrs[j][i].IsInside(MP))
			{
				flag_clickOnControl =1;
				break;
			}
		}
    if (flag_clickOnControl ==1) break;
	}

	if (flag_clickOnControl)
	{
		switch(i)
		{
		case 0:
		    Graph_Cntrs[j][0].Load("I1.xpm");
			assert(Graph_Cntrs[j][0].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][0].Draw();
			Graph_Cntrs[j][1].Load("I2.xpm");
			assert(Graph_Cntrs[j][1].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][1].Draw();
			W.RenderText(Position(3.5,5.5) + Offset[j], Position(5,6) + Offset[j], "                    ", Black,White);
			W.RenderText(Position(3.5,5.5) + Offset[j], Position(5,6) + Offset[j], "Auto", Red,White);
			GraphConfig[j].Auto =1; 
			break;
			   
		case 1: 
			Graph_Cntrs[j][1].Load("I1.xpm");
			assert(Graph_Cntrs[j][1].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][1].Draw();
			Graph_Cntrs[j][0].Load("I2.xpm");
			assert(Graph_Cntrs[j][0].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][0].Draw();
            W.RenderText(Position(3.5,5.5) + Offset[j], Position(5,6) + Offset[j], "                  ", Black,White);
            W.RenderText(Position(3.5,5.5) + Offset[j], Position(5,6) + Offset[j], "   y  :  x  =      ", Black,White); 
			W.RenderText(Position(5,5.5) + Offset[j], Position(5.5,6) + Offset[j], GraphConfig[j].scaling_factor_y , Black,White);
			GraphConfig[j].Auto =0; 
			break;

		case 2:
			if (GraphConfig[j].cb[1]==0) 
			{
			Graph_Cntrs[j][2].Load("cbfilled.xpm");
			assert(Graph_Cntrs[j][2].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][2].Draw();
			GraphConfig[j].cb[1]=1;
			}
            else  
			{
			Graph_Cntrs[j][2].Load("cbempty.xpm");
			assert(Graph_Cntrs[j][2].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][2].Draw();
			GraphConfig[j].cb[1]=0;
			}	

			break;
			
			

		case 3:
			if (GraphConfig[j].cb[0]==0)
            {  
            Graph_Cntrs[j][3].Load("cbfilled.xpm");
			assert(Graph_Cntrs[j][3].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][3].Draw();
			GraphConfig[j].cb[0]=1;
			}
			else  
			{
			Graph_Cntrs[j][3].Load("cbempty.xpm");
			assert(Graph_Cntrs[j][3].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][3].Draw();
			GraphConfig[j].cb[0]=0;
			}
			
            break;
			
		case 4:
			if (GraphConfig[j].cb[2]==0)
            {  
            Graph_Cntrs[j][4].Load("cbfilled.xpm");
			assert(Graph_Cntrs[j][4].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][4].Draw();
			GraphConfig[j].cb[2]=1;
			
			}
			else  
			{
			Graph_Cntrs[j][4].Load("cbempty.xpm");
			assert(Graph_Cntrs[j][4].GetStatus() == BitMapOkay);
			Graph_Cntrs[j][4].Draw();
			GraphConfig[j].cb[2]=0;
			}	
			break;

        case 5:
			plotgraph();
			break;
        

		};
	}
    return 1;
  
  
}







































//********THE MAIN PROGRAM********











int ApiMain() {

    

    // ***THE INTERFACE SCREEN***


       
	int i, j ;
        

	read();





                                        // associated the array
    for ( j =0 ; j<NO_GRAPHS; j++)                    // of bitmaps with the
	{                                                 // simple window
		for ( i =0 ; i<NO_OF_CONTROLS; i++)           //W
		{
			Graph_Cntrs [j][i].SetWindow( W);
		}
	}
    


	
	
	W.Open();
	assert(W.GetStatus() == WindowOpen);

    
	
	//The 4 compartments
	W.RenderLine(Position(14,0), Position(14,16),Black,0);
	W.RenderLine(Position(0,7.5), Position(30,7.5),Black,0);
	
	
	//The x-interval(common to all 4 graphs)
    W.RenderText(Position(9.0,0.5) , Position(11,0.5) , "The Domain:", Blue, White);
    W.RenderText(Position(12.0,0.5) , Position(12.5,0.5) , "to", Black, White);
    W.RenderText(Position(11.0,0.5) , Position(12,0.5) , start_domain , Black, White);
    W.RenderText(Position(12.5,0.5) , Position(13.5,0.5) , end_domain , Black, White);
    W.RenderLine(Position(9,1), Position(14,1),Black,0);
	W.RenderLine(Position(9,0), Position(9,1),Black,0);
 
	
	
	for ( j =0 ; j<NO_GRAPHS; j++)
	{   
        
        
		
		//The functions
		W.RenderText(Position(1.0,0.5) + Offset[j], Position(2.5,0.5) + Offset[j], "The function :", Blue, White);
		W.RenderText(Position(1.0,1)+ Offset[j], Position(1.5,1) + Offset[j], "y = ", Black, White);
		W.RenderText(Position(1.0,1)+ Offset[j], Position(5,1) + Offset[j], GraphConfig[j].function , Black, White);
        //The functions	


	    //checkboxes
        W.RenderText(Position(1.5,2.0) + Offset[j], Position(2.0,2.0) + Offset[j], "Utilities : ", Blue, White);
        W.RenderText(Position(1.0,2.5) + Offset[j], Position(2.5,2.5) + Offset[j], "Derivative ", Black, White);
        W.RenderText(Position(3.5,2.5) + Offset[j], Position(4.5,2.5) + Offset[j], "Integral ", Black, White);
        W.RenderText(Position(7,1.5) + Offset[j], Position(8,1.5) + Offset[j], "Enable function: ", Blue, White);

	    Graph_Cntrs[j][2].Load ("cbempty.xpm");
	    assert(Graph_Cntrs[j][2].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][2].SetPosition(Position(1.0, 3) + Offset[j]);
	    Graph_Cntrs[j][2].Draw();

	    Graph_Cntrs[j][4].Load ("cbempty.xpm");
	    assert(Graph_Cntrs[j][4].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][4].SetPosition(Position(3.5, 3) + Offset[j]);
	    Graph_Cntrs[j][4].Draw();
    
	    Graph_Cntrs[j][3].Load ("cbempty.xpm");
	    assert(Graph_Cntrs[j][3].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][3].SetPosition(Position(9, 1.4) + Offset[j]);
	    Graph_Cntrs[j][3].Draw();
        //checkboxes



	    //Radiobuttons
        W.RenderText(Position(2.0,4.5) + Offset[j], Position(2.5,4.5) + Offset[j], "Scaling along y :", Blue, White);
	    W.RenderText(Position(1.0,5) + Offset[j], Position(1.5,5) + Offset[j], "Auto", Black, White);
	    W.RenderText(Position(2.0,5) + Offset[j], Position(3.0,5) + Offset[j], "Manual", Black, White);
        W.RenderText(Position(3.5,5.5) + Offset[j], Position(5,6) + Offset[j], "Auto", Red,White);
 
	    Graph_Cntrs[j][0].Load ("I1.xpm");
	    assert(Graph_Cntrs[j][0].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][0].SetPosition(Position(1.0, 5.5) + Offset[j]);
	    Graph_Cntrs[j][0].Draw();

	    Graph_Cntrs[j][1].Load ("I2.xpm");
	    assert(Graph_Cntrs[j] [1].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][1].SetPosition(Position(2.0, 5.5) + Offset[j]);
	    Graph_Cntrs[j][1].Draw();
        //Radiobuttons
		

		//colour
		W.RenderText(Position(11,6) + Offset[j], Position(11.5,6) + Offset[j], "Colour: ", Blue, White);
		W.RenderText(Position(12,6) + Offset[j], Position(12.5,6) + Offset[j], "******",GraphConfig[j].colour , White);

		//The OK button
        Graph_Cntrs[j][5].Load ("OK.xpm");
	    assert(Graph_Cntrs[j][5].GetStatus() == BitMapOkay);
	    Graph_Cntrs[j][5].SetPosition(Position(11, 6.5) + Offset[j] + Offset[3] );
	    Graph_Cntrs[j][5].Draw();

	}  
    	
	W.SetMouseClickCallback(click);

	
    
	
      






	return 0;
}








int ApiEnd() {
	W.Close();

	return 0;
}









